# -*- coding: UTF-8 -*-
'''
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'''
import re
import urllib
import urlparse, requests

from resources.lib.modules import client, source_utils, debrid
from resources.lib.sources import topcookie


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['1topmoviez.pw']
        self.base_link = 'http://1topmoviez.pw/'
        self.search_link = '?s=%s&post_type=2'
        self.headers = {'User-Agent': client.agent()}

    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            tvshowtitle = tvshowtitle.replace(':', '').replace(' - ', ' ').replace("’", "'")
            title = tvshowtitle
            url = {'tvshowtitle': title}
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            self.imdb = imdb
            url = urlparse.parse_qs(url)
            url = dict([(i, url[i][0]) if url[i] else (i, '') for i in url])
            url['season'], url['episode'], url['imdb'] = season, episode, imdb
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def sources(self, url, hostDict, hostprDict):
        cookies = {'wordpress_logged_in_1f06f931a65f84e890d2db60864004c7': '%s' % topcookie}

        try:
            sources = []
            if debrid.status() == True: raise Exception()

            if url is None:
                return sources

            data = urlparse.parse_qs(url)
            data = dict([(i, data[i][0]) if data[i] else (i, '') for i in data])
            hldr = 'S%02dE%02d' % (int(data['season']), int(data['episode']))
            hldr2 = 'S%02d.E%02d' % (int(data['season']), int(data['episode']))
            season = ['S%02d' % int(data['season']), 'season-%d' % int(data['season']), 'season %d' % int(data['season'])]
            title = data['tvshowtitle']
            imdbid = data['imdb']

            url = urlparse.urljoin(self.base_link, self.search_link % title)
            url = url.replace(' ' ,'%20')
            r = requests.get(url, headers=self.headers).content
            ddata = client.parseDOM(r, 'div class="inner_cover"')
            if len(ddata) < 1 and "'" in title:
                t = title.split("'")[0]
                url = urlparse.urljoin(self.base_link, self.search_link % t)
                url = url.replace(' ' ,'%20')
                r = requests.get(url, headers=self.headers).content
                ddata = client.parseDOM(r, 'div class="inner_cover"')
            for item in ddata:
                try:
                    post = client.parseDOM(item, 'a', ret='href')[0]
                except:
                    continue
                try:
                    name = client.parseDOM(item, 'a', ret='title')[0]
                except:
                    continue
                name = client.replaceHTMLCodes(name)
                n = re.sub(r'[^\w]', '', name)
                t = re.sub(r'[^\w|]', '', title)
                if not self.imdb in item and not t.lower() == n.lower():
                    continue
                result = requests.get(post, cookies=cookies, headers=self.headers).content
                sdata = client.parseDOM(result, 'div class="in_inner_item_dl"')
                for pack in sdata:
                    try:
                        size = re.findall('<span>.+?  :   (\d+.\d+\s*M|\d+\s*M|\d+.\d+\s*G|\d+\s*G|\d+.\d+\s*MB|\d+\s*MB|\d+.\d+\s*GB|\d+\s*GB|\d+.\d+\s*MiB|\d+\s*MiB|\d+.\d+\s*GiB|\d+\s*GiB)</span>', pack, re.DOTALL)[0]
                    except:
                        size = '0'
                    frames = client.parseDOM(pack, 'a', ret='href', attrs={'class': 'btns_dl bg_text_svg'})
                    for link in frames:
                        link = re.sub('s://', '://', link)
                        if link.endswith('/'):
                            continue
                        if not link.endswith('.mp4') and not link.endswith('.mkv'):
                            continue
                        if hldr.lower() in link.lower() or hldr2.lower() in link.lower():
                            if any (x in link.lower() for x in ['trailer', 'extras', 'sample', '.jpg', '.mka', '.srt']):
                                continue
                            if not any (x in link.lower() for x in ['.mp4', '.mkv']):
                                continue
                            host = link.split('/')[2].replace('.', '')[:7]
                            info = link.split('/')[-1]
                            quality = source_utils.check_direct_url(info)
                            if not size == '0':
                                size = size.lower().replace('gib', 'gb').replace('mib', 'mb')
                                if 'mb' not in size.lower() and 'gb' not in size.lower():
                                    size = size.lower().replace('g', 'gb').replace('m', 'mb')
                                info = ('{0} | {1} | GKoBu').format(size, info)
                            else:
                                info = '{0} | GKoBu'.format(info)
                            link += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), link)
                            sources.append({'source': host, 'quality': quality, 'language': 'en',
                                            'url': link, 'info': info, 'direct': True, 'debridonly': False})
            return sources
        except Exception:
            return sources

    def resolve(self, url):
        return url

