# -*- coding: UTF-8 -*-
'''
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'''
import re
import urllib
import urlparse

from resources.lib.modules import client, source_utils, debrid


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['saberfun1.ir']
        self.base_link = 'https://saberfun1.ir/'
        self.search_link = '?s=%s'
        self.headers = {'User-Agent': client.agent()}

    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            tvshowtitle = tvshowtitle.replace(':', '').replace(' - ', ' ').replace("'", "").replace("’", "")
            title = tvshowtitle
            url = {'tvshowtitle': title}
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            self.imdb = imdb
            url = urlparse.parse_qs(url)
            url = dict([(i, url[i][0]) if url[i] else (i, '') for i in url])
            url['season'], url['episode'] = season, episode
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def sources(self, url, hostDict, hostprDict):
        try:
            sources = []
            if debrid.status() == True: raise Exception()

            if url is None:
                return sources

            data = urlparse.parse_qs(url)
            data = dict([(i, data[i][0]) if data[i] else (i, '') for i in data])
            hldr = 'S%02dE%02d' % (int(data['season']), int(data['episode']))
            hldr2 = 'S%02d.E%02d' % (int(data['season']), int(data['episode']))
            season = ['S%02d' % int(data['season']), 'S%d' % int(data['season']), 'season-%d' % int(data['season']), 'season %d' % int(data['season']), 'season%s%d' % ('%20', int(data['season']))]
            title = data['tvshowtitle']

            url = urlparse.urljoin(self.base_link, self.search_link % title)
            url = url.replace(' ' ,'%20')
            r = client.request(url, headers=self.headers)
            sdata = client.parseDOM(r, 'div class="postboxsb"')
            for item in sdata:
                n = client.parseDOM(item, 'h2')[0]
                n = n.encode('utf-8')
                n = re.sub(r'[^\w]', '', n)
                t = re.sub(r'[^\w]', '', title)
                if not self.imdb in item and not t.lower() == n.lower():
                    continue
                try:
                    post = client.parseDOM(item, 'a', ret='href')[0]
                except:
                    continue
                result = client.request(post, headers=self.headers)
                body = client.parseDOM(result, 'div class="postboxsb"')
                body = client.parseDOM(body, 'div class="content_post"')
                results = client.parseDOM(body, 'a', ret='href')
                for dirlink in results:
                    if not dirlink.startswith('http://') and not dirlink.startswith('https://'):
                        dirlink = dirlink.replace('http:', 'http://').replace('https:', 'https://')
                    if not dirlink.endswith('.mkv') and not dirlink.endswith('.mp4') and not [ i for e in season if e.lower() in dirlink.lower() ]:
                        continue
                    if not dirlink.endswith('.mkv') and not dirlink.endswith('.mp4') and [ i for e in season if e.lower() in dirlink.lower() ]:
                        dirlink = dirlink + '/'
                        regex = '<td class="link"><a href="(.+?)" title=".+?">.+?</a></td><td class="size">(.+?)</td>'
                        result2 = client.request(dirlink, headers=self.headers)
                        results2 = client.parseDOM(result2, 'tbody')
                        results2 = client.parseDOM(results2, 'tr')
                        for frame in results2:
                            link = client.parseDOM(frame, 'a', ret='href')[0]
                            size = client.parseDOM(frame, 'td', attrs={'class': 'size'})[0]
                            if link.startswith('.') or link.startswith('?'):
                                continue
                            sublink = urlparse.urljoin(dirlink, link)
                            if link.endswith('/'):
                                subhtml = client.request(sublink, headers=self.headers)
                                subres = client.parseDOM(subhtml, 'tbody')
                                subres = client.parseDOM(subres, 'tr')
                                for newframe in subres:
                                    slink = client.parseDOM(newframe, 'a', ret='href')[0]
                                    size = client.parseDOM(newframe, 'td', attrs={'class': 'size'})[0]
                                    if slink.startswith('.') or slink.startswith('?'):
                                        continue
                                    if hldr.lower() in slink.lower() or hldr2.lower() in slink.lower():
                                        nlink = urlparse.urljoin(sublink, slink)
                                        host = nlink.split('/')[2].replace('.', '')[:7]
                                        try:
                                            size = source_utils.convert_size(int(size))
                                            info = nlink.split('/')[-1]
                                            info = ('{0} | {1} | GKoBu').format(size, info)
                                        except:
                                            size = size.replace('i', '')
                                            info = nlink.split('/')[-1]
                                            info = ('{0} | {1} | GKoBu').format(size, info)
                                        quality = source_utils.check_direct_url(info)
                                        # nlink += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), nlink)
                                        sources.append({'source': host, 'quality': quality, 'language': 'en',
                                                        'url': nlink, 'info': info, 'direct': True, 'debridonly': False})
                            else:
                                if hldr.lower() in link.lower() or hldr2.lower() in link.lower():
                                    host = sublink.split('/')[2].replace('.', '')[:7]
                                    try:
                                        size = source_utils.convert_size(int(size))
                                        info = sublink.split('/')[-1]
                                        info = ('{0} | {1} | GKoBu').format(size, info)
                                    except:
                                        size = size.replace('i', '')
                                        info = sublink.split('/')[-1]
                                        info = ('{0} | {1} | GKoBu').format(size, info)
                                    quality = source_utils.check_direct_url(info)
                                    # sublink += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), sublink)
                                    sources.append({'source': host, 'quality': quality, 'language': 'en',
                                                    'url': sublink, 'info': info, 'direct': True, 'debridonly': False})
                    
                    if hldr.lower() in dirlink.lower() or hldr2.lower() in dirlink.lower():
                        link = dirlink
                        host = link.split('/')[2].replace('.', '')[:7]
                        info = link.split('/')[-1]
                        quality = source_utils.check_direct_url(info)
                        info = '{0} | GKoBu'.format(info)
                        # link += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), link)
                        sources.append({'source': host, 'quality': quality, 'language': 'en',
                                        'url': link, 'info': info, 'direct': True, 'debridonly': False})
            return sources
        except Exception:
            return sources

    def resolve(self, url):
        return url

