# -*- coding: utf-8 -*-

'''
    Filmnet Add-on (C) 2017
    Credits to Exodus and Covenant; our thanks go to their creators

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

import urllib, urlparse, re, base64

from resources.lib.modules import cleantitle
from resources.lib.modules import client
from resources.lib.modules import source_utils
from resources.lib.modules import dom_parser2


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['liomenoi.com']
        self.base_link = 'https://liomenoi.xyz/'
        self.post_link = 'https://liomenoi.xyz/wp-admin/admin-ajax.php'
        self.search_link = 'action=yolo_live_search&input={}'

    def movie(self, imdb, title, localtitle, aliases, year):
        try:
            url = self.__search([localtitle] + source_utils.aliases_to_array(aliases), year, 'movie')
            if not url and title != localtitle: url = self.__search([title] + source_utils.aliases_to_array(
                aliases), year, 'movie')
            return url
        except BaseException:
            return

    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            url = self.__search([localtvshowtitle] + source_utils.aliases_to_array(aliases), year, 'show')
            if not url and tvshowtitle != localtvshowtitle: url = self.__search(
                [tvshowtitle] + source_utils.aliases_to_array(aliases), year, 'show')
            return url
        except BaseException:
            return

    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            if not url:
                return

            self.ep = int(episode)
            r = client.request(urlparse.urljoin(self.base_link, url))
            r = client.parseDOM(r, 'a', ret='href')
            s = '/season/%d/' % int(season)
            r = [i for i in r if s in i]

            return source_utils.strip_domain(r[0])
        except BaseException:
            return

    def __search(self, titles, year, type):
        try:

            check = '/tainies/' if type == 'movie' else '/tv-series/'
            tit = [i.split(':')[0] for i in titles]
            query = [self.search_link.format(urllib.quote_plus(cleantitle.getsearch(i))) for i in tit]
            # query = [urlparse.urljoin(self.base_link, i) for i in query]
            t = [cleantitle.get(i) for i in set(titles) if i]
            for u in query:
                try:

                    r = client.request(self.post_link, post=u, referer=self.base_link)
                    posts = client.parseDOM(r, 'li', attrs={'id': r'post-\d+'})
                    r = [client.parseDOM(i, 'a', ret='href')[0] for i in posts if year == re.findall(r'\((\d{4})[\)|-]',i , re.DOTALL)[0]]
                    # r = [(i[0], i[1]) for i in r if year == re.findall(r'(\d{4})', i[1], re.DOTALL)[0]]
                    # print r
                    r = [i for i in r if check in i]
                    if len(r) == 1:
                        return source_utils.strip_domain(r[0])
                    else:
                        r = [(i[0]) for i in r if cleantitle.get(i[1]) in t]
                        return source_utils.strip_domain(r[0])

                except BaseException:
                    pass

            return
        except BaseException:
            return

    def sources(self, url, hostDict, hostprDict):
        sources = []

        try:
            if not url:
                return sources

            query = urlparse.urljoin(self.base_link, url)
            r = client.request(query)

            if not 'tv-series' in query:
                links = client.parseDOM(r, 'tbody')
                links = client.parseDOM(links, 'a', ret='href')
            else:
                links = client.parseDOM(r, 'ul', attrs={'class':'collapsible'})[0]
                pattern = r'href="#">.+?%d\s*<span class="right lmn-num-of-ep">(.+?)</table></div>' % self.ep
                links = re.findall(pattern, links)
                links = client.parseDOM(links, 'a', ret='href')

            for url in links:
                try:
                    if 'liomenoi' in url:
                        url = re.findall(r'liomenoi.+?link=(.+?)&title', url)[0]
                        url = base64.b64decode(url)
                    if 'target' in url: continue

                    if 'redvid' in url:
                        data = client.request(url)
                        url = client.parseDOM(data, 'iframe', ret='src')[0]

                    if any(x in url for x in ['.online', 'xrysoi.se', 'filmer', '.bp', '.blogger', 'youtu']):
                        continue
                    if 'crypt' in url:
                        host = re.findall(r'embed\/(.+?)\/', url)[0]
                        url = url
                    else:
                        valid, host = source_utils.is_host_valid(url, hostDict)
                        if not valid: continue
                    quality = 'SD'
                    info = 'GR-SUB'

                    sources.append({'source': host, 'quality': quality, 'language': 'en', 'url': url, 'info': info,
                                    'direct':False,'debridonly': False})
                except BaseException:
                    pass
            return sources
        except BaseException:
            return sources

    def resolve(self, url):
        if 'crypt' in url:
            data = client.request(url)
            url = re.findall(r'''onclick="location.href=['"]([^"']+)["']''', data, re.DOTALL)[0]
            url = re.sub(r'(?:playvideo-|\?playvid)', '', url)

        return url