 # -*- coding: UTF-8 -*-
'''
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'''
import re
import urllib
import urlparse

from resources.lib.modules import client, source_utils, debrid


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['anime-list9.site']
        self.base_link = 'https://anime-list9.site/'
        self.search_link = 'search?type=series&s=%s'
        self.headers = {'User-Agent': client.agent()}

    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            tvshowtitle = tvshowtitle.replace(':', '').replace(' - ', ' ').replace("'", "").replace("’", "")
            title = tvshowtitle
            url = {'tvshowtitle': title}
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            self.imdb = imdb
            url = urlparse.parse_qs(url)
            url = dict([(i, url[i][0]) if url[i] else (i, '') for i in url])
            url['season'], url['episode'] = season, episode
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def sources(self, url, hostDict, hostprDict):
        try:
            sources = []
            if debrid.status() == True: raise Exception()

            if url is None:
                return sources

            data = urlparse.parse_qs(url)
            data = dict([(i, data[i][0]) if data[i] else (i, '') for i in data])
            hldr = 'S%02dE%02d' % (int(data['season']), int(data['episode']))
            hldr2 = 'S%02d.E%02d' % (int(data['season']), int(data['episode']))
            season = ['S%02d' % int(data['season']), 'S%d' % int(data['season']), 'season-%d' % int(data['season']), 'season %d' % int(data['season']), 'season%s%d' % ('%20', int(data['season']))]
            title = data['tvshowtitle']

            url = urlparse.urljoin(self.base_link, self.search_link % title)
            url = url.replace(' ' ,'%20')
            r = client.request(url, headers=self.headers)
            sdata = client.parseDOM(r, 'div class="col-12 col-lg col-sm-8 col-xs-12 d-flex justify-content-center"')
            for item in sdata:
                try:
                    post = client.parseDOM(item, 'a', ret='href')[0]
                except:
                    continue
                try:
                    name = client.parseDOM(item, 'a', ret='title')[0]
                except:
                    continue
                name = client.replaceHTMLCodes(name)
                n = re.sub(r'[^\w]', '', name)
                t = re.sub(r'[^\w]', '', title)
                if not t.lower() == n.lower() and not self.imdb in item:
                    continue
                result = client.request(post, headers=self.headers)
                results = client.parseDOM(result, 'div class="episodes-series__item"')
                for frame in results:
                    try:
                        try:
                            link = client.parseDOM(frame, 'a', ret='href', attrs={'rel': 'nofollow'})[0]
                            link = link.replace('?dir=', '')
                        except:
                            continue
                        if not link.startswith('http://') and not link.startswith('https://'):
                            link = link.replace('http:', 'http://').replace('https:', 'https://')
                        if not link.endswith('.mkv') and not link.endswith('.mp4') and not [ i for e in season if e.lower() in link.lower() ]:
                            continue
                        if not link.endswith('.mkv') and not link.endswith('.mp4') and [ i for e in season if e.lower() in link.lower() ]:
                            link = link + '/'
                            regex = '<tr><td class="link"><a href="(.+?)" title=.+?</a></td><td class="size">(.+?)</td>'
                            regex2 = '<a href="(.+?)" title=".+?".+?class="size">(.+?)</td>'
                            regex3 = 'a href="(.+?)".+?\s+(\d+|\-)\s+'
                            result2 = client.request(link, headers=self.headers)
                            results2 = re.findall(regex, result2, re.DOTALL)
                            if len(results2) < 1:
                                results2 = re.findall(regex2, result2, re.DOTALL)
                            if len(results2) < 1:
                                results2 = re.findall(regex3, result2, re.DOTALL)
                            for eplink, size in results2:
                                if eplink.startswith('.') or eplink.startswith('?'):
                                    continue
                                if hldr.lower() in eplink.lower() or hldr2.lower() in eplink.lower():
                                    url = urlparse.urljoin(link, eplink)
                                    host = url.split('/')[2].replace('.', '')[:7]
                                    info = url.split('/')[-1]
                                    quality = source_utils.check_direct_url(info)
                                    try:
                                        size = source_utils.convert_size(int(size))
                                        info = '{0} | {1} | GKoBu'.format(size, info)
                                    except:
                                        size = size.replace('i', '')
                                        info = '{0} | {1} | GKoBu'.format(size, info)
                                    url += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), url)
                                    sources.append({'source': host, 'quality': quality, 'language': 'en',
                                                    'url': url, 'info': info, 'direct': True, 'debridonly': False})
                        if hldr.lower() in link.lower() or hldr2.lower() in link.lower():
                            url = link
                            host = url.split('/')[2].replace('.', '')[:7]
                            info = url.split('/')[-1]
                            quality = source_utils.check_direct_url(info)
                            info = '{0} | GKoBu'.format(info)
                            url += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), url)
                            sources.append({'source': host, 'quality': quality, 'language': 'en',
                                            'url': url, 'info': info, 'direct': True, 'debridonly': False})
                    except:
                        continue
            return sources
        except Exception:
            return sources

    def resolve(self, url):
        return url

