# -*- coding: utf-8 -*-
'''
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'''

import re, requests
from resources.lib.modules import source_utils, debrid


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['www.film2movie.asia']
        self.base_link = 'https://www.film2movie.asia/'
        self.search_link = 'search/%s'

    def movie(self, imdb, title, localtitle, aliases, year):
        try:
            title = title
            self.title = '%s %s' % (title, year)
            self.title = self.title.replace(':', '').replace(' - ', ' ').replace("'", "").replace('...', ' ').replace("’", "").replace('!', '')
            self.year = year
            self.imdb = imdb
            if self.imdb == 'tt7713068':
                self.title = 'Birds of Prey'
            url = self.base_link + self.search_link % self.title
            url = url.replace(' ', '%20')
            return url
        except:
            return

    def sources(self, url, hostDict, hostprDict):
        try:
            sources = []
            if debrid.status() == True: raise Exception()
            if url is None:
                return sources
            r = requests.get(url, timeout=20).content
            posts = re.findall('<br><a href="(.+?)" title="(.+?)" class', r)
            if posts is None:
                return sources
            for post, name in posts:
                n = name.replace('&#8217;', '').replace(':', '').replace(' - ', ' ').replace("'", "").replace('...', ' ').replace("’", "").replace('!', '')
                if not self.title.lower() in n.lower():
                    continue
                result = requests.get(post, timeout=20).content
                frames = re.findall('<a href="(.+?)"', result)
                for frame in frames:
                    # f = cleantitle.get(frame).replace('%21', '').replace('%27', '').replace('%2C', '').split(self.year)[0]
                    # if not t.lower() == f.lower():
                        # continue
                    if not self.year in frame:
                        continue
                    if any (x in frame.lower() for x in ['trailer', 'extras', 'sample', '.jpg']):
                        continue
                    if not any (x in frame.lower() for x in ['.mp4', '.mkv']):
                        continue
                    url = frame
                    host = url.split('/')[2].replace('.', '')[:7]
                    if 'ftk' in host: host = 'slow-server'
                    info = url.split('/')[-1]
                    quality = source_utils.check_direct_url(info)
                    sources.append({'source': host, 'quality': quality, 'language': 'en', 'url': url, 'info': info, 'direct': True, 'debridonly': False})
            return sources
        except:
            return sources

    def resolve(self, url):
        return url
