# -*- coding: UTF-8 -*-
'''
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'''
import re
import urllib
import urlparse

from resources.lib.modules import client, source_utils, debrid


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['mymojoo.info']
        self.base_link = 'https://mymojoo.info/'
        self.search_link = '?s=%s&btnSubmit='
        self.headers = {'User-Agent': client.agent()}

    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            tvshowtitle = tvshowtitle.replace(':', '').replace(' - ', ' ').replace("'", "").replace("’", "")
            title = tvshowtitle
            url = {'tvshowtitle': title}
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            url = urlparse.parse_qs(url)
            url = dict([(i, url[i][0]) if url[i] else (i, '') for i in url])
            url['season'], url['episode'] = season, episode
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def sources(self, url, hostDict, hostprDict):
        try:
            sources = []
            if debrid.status() == True: raise Exception()

            if url is None:
                return sources

            # headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0'}
            data = urlparse.parse_qs(url)
            data = dict([(i, data[i][0]) if data[i] else (i, '') for i in data])
            hldr = 'S%02dE%02d' % (int(data['season']), int(data['episode']))
            season = ['S%02d' % int(data['season']), 'season-%d' % int(data['season']), 'season %d' % int(data['season'])]
            title = data['tvshowtitle']

            url = urlparse.urljoin(self.base_link, self.search_link % title)
            url = url.replace(' ' ,'%20')
            r = client.request(url, headers=self.headers)
            posts = re.findall('"title_post_list"> <a href="(.+?)">s<h\d>(.+?)</h\d>', r, re.DOTALL)
            
            for post, name in posts:
                t = title.replace("'", "").replace("’", "")
                n = name.replace('&#8217;', '').replace(':', '').replace(' - ', ' ').replace("'", "").replace("’", "")
                if not t.lower() in n.lower():
                    continue
                if len(posts) > 1 and 'season' in n.lower() and not [i for e in season if e.lower() in n.lower()]:
                        continue
                result = client.request(post, headers=self.headers)
                results = re.findall('</span> :.+?href="(.+?)"', result)
                old = re.findall('<a href="(.+?)".+?target="', result)
                for dirlink in results:
                    if hldr.lower() in dirlink.lower():
                        link = dirlink
                        host = link.split('/')[2].replace('.', '')[:7]
                        info = link.split('/')[-1]
                        quality = source_utils.check_direct_url(info)
                        sources.append({'source': host, 'quality': quality, 'language': 'en',
                                        'url': link, 'info': info, 'direct': True, 'debridonly': False})
                for oldlink in old:
                    if not oldlink.endswith('/'): oldlink = oldlink + '/'
                    if [i for e in season if e.lower() in oldlink.lower()]: 
                        result2 = client.request(oldlink, headers=self.headers)
                        results2 = re.findall('a href="(.+?)".+?\s+(\d+|\-)\s+', result2)
                        for dirlink, size in results2:
                            if dirlink.startswith('.') or dirlink.startswith('?'):
                                continue
                            sublink = urlparse.urljoin(oldlink, dirlink)
                            if dirlink.endswith('/'):
                                subhtml = client.request(sublink, headers=self.headers)
                                subres = re.findall('a href="(.+?)".+?\s+(\d+|\-)\s+', subhtml)
                                for link, size in subres:
                                    if link.startswith('.') or link.startswith('?'):
                                        continue
                                    if hldr.lower() in link.lower():
                                        link = urlparse.urljoin(sublink, link)
                                        host = link.split('/')[2].replace('.', '')[:7]
                                        try:
                                            size = source_utils.convert_size(int(size))
                                            info = link.split('/')[-1]
                                            info = '{0} | {1}'.format(size, info)
                                        except:
                                            info = link.split('/')[-1]
                                        quality = source_utils.check_direct_url(info)
                                        sources.append({'source': host, 'quality': quality, 'language': 'en',
                                                        'url': link, 'info': info, 'direct': True, 'debridonly': False})
                            else:
                                if hldr.lower() in dirlink.lower():
                                    link = urlparse.urljoin(sublink, dirlink)
                                    host = link.split('/')[2].replace('.', '')[:7]
                                    try:
                                        size = source_utils.convert_size(int(size))
                                        info = link.split('/')[-1]
                                        info = '{0} | {1}'.format(size, info)
                                    except:
                                        info = link.split('/')[-1]
                                    quality = source_utils.check_direct_url(info)
                                    sources.append({'source': host, 'quality': quality, 'language': 'en',
                                                    'url': link, 'info': info, 'direct': True, 'debridonly': False})
            return sources
        except Exception:
            return sources

    def resolve(self, url):
        return url

