# -*- coding: utf-8 -*-

'''
    Filmnet Add-on (C) 2017
    Credits to Exodus and Covenant; our thanks go to their creators

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

import re
import urllib
import urlparse

from resources.lib.modules import client


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['tainiomania.ucoz.com', 'tainio-mania.com']
        self.base_link = 'http://tainio-mania.co/'
        self.search_link = 'index.php?do=search'


    def movie(self, imdb, title, localtitle, aliases, year):
        try:
            url = {'imdb': imdb, 'localtitle': localtitle, 'title': title, 'aliases': aliases,'year': year}
            url = urllib.urlencode(url)
            return url
        except:
            return

    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            url = {'imdb': imdb, 'tvdb': tvdb, 'tvshowtitle': tvshowtitle, 'aliases': aliases, 'year': year}
            url = urllib.urlencode(url)
            return url
        except:
            return

    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            if url == None: return

            url = urlparse.parse_qs(url)
            url = dict([(i, url[i][0]) if url[i] else (i, '') for i in url])
            url['title'], url['premiered'], url['season'], url['episode'] = title, premiered, season, episode
            url = urllib.urlencode(url)
            return url
        except:
            return


    def sources(self, url, hostDict, hostprDict):
        sources = []

        try:
            if not url:
                return sources
            # scraper = cfscrape.create_scraper()
            headers = {'User-Agent': client.agent(),
                       'Referer': self.base_link}

            data = urlparse.parse_qs(url)
            data = dict([(i, data[i][0]) if data[i] else (i, '') for i in data])
            imdb = data['imdb']
            print imdb
            title = data['tvshowtitle'] if 'tvshowtitle' in data else data['title']
            hdlr = 's%02de%02d' % (int(data['season']), int(data['episode'])) if 'tvshowtitle' in data else data['year']
            query = '{}'.format(data['tvshowtitle']) if 'tvshowtitle' in data else '%s %s' % (
            data['title'], data['year'])
            query = re.sub(r'(\\\|/| -|:|;|\*|\?|"|\'|<|>|\|)', ' ', query)

            pdata = 'do=search&subaction=search&search_start=0&full_search=0&result_from=1&story={}'.format(imdb)
            plink = urlparse.urljoin(self.base_link, self.search_link)
            html = client.request(plink, post=pdata, headers=headers)
            post = client.parseDOM(html, 'div', attrs={'class': 't_title'})[0]
            postlink = client.parseDOM(post, 'a', ret='href')[0]
            if 'tvshowtitle' in data:
                season, episode = data['season'], data['episode']
                r = client.request(postlink, headers).replace('\\', '')
                pdata = re.findall(r'''mod:\s*'(\w+)',\s*news_id:\s*'(.+?)'\}''', r, re.DOTALL)[0]
                pdata = 'mod={}&news_id={}'.format(pdata[0], pdata[1])
                headers['Referer'] = query
                plink = urlparse.urljoin(self.base_link, '/engine/ajax/controller.php')
                post = client.request(plink, post=pdata, headers=headers).replace('\\', '')
                txt = re.findall(r'''Playerjs.+?file:['"](.+?)['"]\}''', post, re.DOTALL)[0]
                data = client.request(urlparse.urljoin(self.base_link, txt), headers=headers)
                sep = '%dx%02d' % (int(season), int(episode))
                url = re.findall('file":"(.+?.mp4)"', data, re.DOTALL)
                url = [i for i in url if sep in str(i)][0]
                url += '|User-Agent=%s&Referer=%s' % (urllib.quote_plus(client.agent()), urllib.quote_plus(query))
                quality = '720p'

                sources.append({'source': 'DL', 'quality': quality, 'language': 'en', 'url': url, 'info': 'GR-SUB',
                                'direct': True, 'debridonly': False})

            else:
                query = url
                r = client.request(postlink, headers)
                pdata = re.findall(r'''mod:\s*'(\w+)',\s*news_id:\s*'(.+?)'\}''', r, re.DOTALL)[0]
                pdata = 'mod={}&news_id={}'.format(pdata[0], pdata[1])
                headers['Referer'] = query
                plink = urlparse.urljoin(self.base_link, '/engine/ajax/controller.php')
                post = client.request(plink, post=pdata, headers=headers).replace('\\', '')
                txt = re.findall('''Playerjs.+?file:['"](.+?)['"]''', post, re.DOTALL)[0]
                # txt = client.parseDOM(r, 'span', {'class': "pltx"})[0]
                url = urlparse.urljoin(self.base_link, txt)
                url += '|User-Agent=%s&Referer=%s' % (urllib.quote_plus(client.agent()), urllib.quote_plus(query))
                sources.append({'source': 'DL', 'quality': '720p', 'language': 'en', 'url': url,
                                'info': 'GR-SUB', 'direct': True, 'debridonly': False})

            return sources
        except BaseException:
            return sources

    def resolve(self, url):
        return url